package com.om.utils;


import com.om.OperationApplication;
import com.om.entity.dto.ControlListMap;
import freemarker.template.Configuration;
import freemarker.template.Template;
import java.io.File;
import java.io.FileWriter;
import java.io.StringWriter;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HtmlGenerator {


    public static File generateHtmlByMap(Integer id, List<ControlListMap> controlListMap
            , Map<String, String> baseMap, Map<String, String> companyMap){

        try {
            Configuration cfg = new Configuration(Configuration.VERSION_2_3_31);
            cfg.setClassForTemplateLoading(OperationApplication.class, "../../template/static/");

            Template template = cfg.getTemplate("report.html");
            String format = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            StringWriter out = new StringWriter();
            Map<String, Object> data = new HashMap<>();
            data.put("reportTime",format);
            data.put("baseMap", baseMap);
            data.put("controlListMap", controlListMap);
            data.put("companyMap", companyMap);
            data.put("id", id);

            template.process(data, out);

            // 将HTML内容写入文件
            String htmlContent = out.toString();
            String yyyyMMdd = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd"));
            String outputPath = "src/main/resources/template/static/"+yyyyMMdd+"outputH5"+id+".html";
            FileWriter fileWriter = new FileWriter(outputPath);
            fileWriter.write(htmlContent);
            File file = new File("src\\main\\resources\\template\\static\\"+yyyyMMdd+"outputH5"+id+".html");
            fileWriter.close();
            System.out.println("HTML文件已生成：" + outputPath);
            return file;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    public static void main(String[] args) {

        Map<String, String> baseMap = new HashMap<>();
        baseMap.put("车架号", "01");
        baseMap.put("里程", "52Km");
        baseMap.put("年款", "1000");
        baseMap.put("报告编号", "01240222242360836214099968");
        baseMap.put("诊断路径", "诊断>五菱新能源TEST");
        baseMap.put("SN", "WL01000005");

        Map<String, String> faultCodeMap = new HashMap<>();
        faultCodeMap.put("B111716", "供电电压电量过低");
        faultCodeMap.put("U007588", "CHA CAN网段控制器BuSOff");
        faultCodeMap.put("P129600", "非N或P档无法ready");
        faultCodeMap.put("P129700", "充电连接信号有效无法ready");

        Map<String, String> versionMap = new HashMap<>();
        versionMap.put("引导软件标识符", "BtswV1.00");
        versionMap.put("零件号", "0000000000");
        versionMap.put("定义的ECU软件编号", "G050_1HB20");
        versionMap.put("定义的ECU硬件编号", "G050_1HB20");
        versionMap.put("供应商代码", "S-00009475");
        versionMap.put("ECU名称", "0000000VCU");
        versionMap.put("供应商硬件版本号", "V005.001");
        versionMap.put("供应商软件版本号", "V001.000");
        versionMap.put("ECU序列编号", "HB00009475230425T000000");
        versionMap.put("车辆识别号", "LZWADAGA4LB460541");
        versionMap.put("SK码", "00000000000000000000000000000000");


        Map<String, String> companyMap = new HashMap<>();
        companyMap.put("公司", "XXXXXX");
        companyMap.put("地址", "XXXXXXXXXXXX");
        companyMap.put("电话", "18888888888");

        List<ControlListMap> controlListMap = new ArrayList<>();
        ControlListMap controlListMap1 = new ControlListMap();
        controlListMap1.setName("G050右舵车/VCU整车控制器");
        controlListMap1.setVersionMap(versionMap);
        controlListMap1.setFaultCodeMap(faultCodeMap);
        controlListMap.add(controlListMap1);
        File file = generateHtmlByMap(1, controlListMap, baseMap, companyMap);

        System.out.println(file.getName());
    }
}
